#!/usr/bin/perl

@datasets = ("dataset_long1.ss", "dataset_long16.ss", "dataset_long2.ss", "dataset_long4.ss", "dataset_long8.ss", "dataset_simultaneous.ss", "dataset_solid.ss", "dataset_spiked.ss");
@memory_calls = (85, 90, 95, 100);
@os_calls = (0, 1, 2, 3, 4, 5);
@context_switchs = (0, 5, 10, 15);
@frame_sizes = (100, 200, 500, 1000, 5000);
@schedulers = ("schedule_one.ss", "schedule_shift.ss", "schedule_shift_persist.ss", "schedule_top.ss", "schedule_top_persist.ss");

open(OUTPUTDATA, ">datafile.csv");
# open(TIMEDATA, ">timedata.csv");

foreach $dataset (@datasets) {
foreach $memory_call (@memory_calls) {
foreach $os_call (@os_calls) {
foreach $context_switch (@context_switchs) {
foreach $frame_size (@frame_sizes) {
foreach $scheduler (@schedulers) {
     open(VARIABLES, ">variables.ss");
     print VARIABLES "
(define frame-size $frame_size)
(define context-switch-time $context_switch)

(define memory-calls $memory_call)
(define os-calls $os_call)
(define os-length 200)

(define scheduler \"$scheduler\")
(define dataset \"$dataset\")";
     close(VARIABLES);

     # open(DATAIN, "petite run.ss | tail -3 |");
     open(DATAIN, "petite run.ss | tail -1 |");
     $bob = <DATAIN>;
     chop($bob);
     print OUTPUTDATA "$bob\n";
     # $bob = <DATAIN>;
     # chop($bob);
     # print TIMEDATA "$bob\n";
     # $bob = <DATAIN>;
     # chop($bob);
     # print TIMEDATA "$bob\n";
     close(DATAIN);
     } # scheduler...
     }}}}}

close(OUTPUTDATA);
