; This is a scheduling algorithim that always puts the top four
; processes in the os que in to the processor.

(define schedule
     (lambda (os_proc processor_proc)
          (letrec
               ((myos (append os-stack (append os_proc processor_proc)))
                (origid (sort < (map process-id processor_proc)))
                (helper 
                    (lambda (proclst retlst number)
                         (if (null? proclst)
                              (list '() retlst)
                              (if (eq? number 0)
                                   (list proclst retlst)
                                   (helper (cdr proclst) (cons (car proclst) retlst) (- number 1))
                                   )
                              )
                         )
                    ))
               ; (printf ".")
               (set! os-stack '())
               (letrec
                    ((retlst (helper myos '() 4))
                     (countdiff
                         (lambda (number lsta lstb)
                              (if (or (null? lsta) (null? lstb)) number
                                   (if (eq? (car lsta) (car lstb))
                                        (countdiff (- number 1) (cdr lsta) (cdr lstb))
                                        (if (< (car lsta) (car lstb))
                                             (countdiff number (cdr lsta) lstb)
                                             (countdiff number lsta (cdr lstb))
                                             )
                                        )
                                   )
                              )
                         )
                     )
                    (set! global-time (+ global-time (* context-switch-time (countdiff 4 origid (sort < (map process-id (cadr retlst)))))))
                    retlst
                    )
               )
          )
     )

(define schedule-realtime
     (lambda (proc-list)
          (cdr proc-list)
          )
     )
