% Solid Dataset 
% Looking at wait time
makegraph(7, 90, 0.01, [0 5 10 15], 1000, 9);
title('Solid');
print -depsc -tif solid_avwait_context
makegraph(7, 90, 0.01, [0 5 10 15], 1000, 10);
title('Solid');
print -depsc -tif solid_maxwait_context
% looking at response time
makegraph(7, 90, 0.01, [0 5 10 15], 1000, 6);
title('Solid');
print -depsc -tif solid_avresponse_context
makegraph(7, 90, 0.01, [0 5 10 15], 1000, 7);
title('Solid');
print -depsc -tif solid_maxresponse_context
% looking at throughput
makegraph(7, 90, 0.01, [0 5 10 15], 1000, 11);
title('Solid');
print -depsc -tif solid_throughput_context


% Simultaneous Dataset
% wait time
makegraph(6, [10 20 30 40 50 60 70 80 90 100], 0.01, 10, 1000, 9);
title('Simultaneous');
print -depsc -tif simul_avwait_memcall
makegraph(6, [10 20 30 40 50 60 70 80 90 100], 0.01, 10, 1000, 10);
title('Simultaneous');
print -depsc -tif simul_maxwait_memcall
% throughput
makegraph(6, [10 20 30 40 50 60 70 80 90 100], 0.01, 10, 1000, 11);
title('Simultaneous');
print -depsc -tif simul_throughput_memcall


% Spiked Dataset
% throughput
makegraph(5, 90, 0.01, [0 5 10 15], 1000, 11);
title('Spiked');
print -depsc -tif spiked_throughput_context
% Response time
makegraph(5, 90, 0.01, [0 5 10 15], 1000, 6);
title('Spiked');
print -depsc -tif spiked_avresponse_context
makegraph(5, 90, 0.01, [0 5 10 15], 1000, 7);
title('Spiked');
print -depsc -tif spiked_maxresponse_context
% CPU Utilization
makegraph(5, 90, 0.01, [0 5 10 15], 1000, 1);
title('Spiked');
print -depsc -tif spiked_utilization_context

% Long Dataset
% throughput
makegraph([1 2 4 8 16], 90, 0.01, 10, 1000, 11);
title('Long');
print -depsc -tif long_throughput_dataset
% CPU Utilization
makegraph([1 2 4 8 16], 90, 0.01, 10, 1000, 1);
title('Long');
print -depsc -tif long_utilization_dataset
% Wait Time
makegraph([1 2 4 8 16], 90, 0.01, 10, 1000, 9);
title('Long');
print -depsc -tif long_avwait_dataset
makegraph([1 2 4 8 16], 90, 0.01, 10, 1000, 10);
title('Long');
print -depsc -tif long_maxwait_dataset
% throughput by oscall
makegraph(8, 90,[0.00 0.01 0.02 0.03 0.04 0.05], 10, 1000, 11);
title('Long 8');
print -depsc -tif long_throughput_oscall
