; need defined ahead of time:
; proccess
; context-switch-time
; global-time
; proc-os

; This implements shifting in the processes.

(define schedule
; uses os-stack
     (lambda (os_proc prossessor_proc)
          (let*
               ((myos (append os_proc prossessor_proc))
                )
               ; (printf "schedule: ~a ~a ~a~%" (length os_proc) (length prossessor_proc) (length os-stack))
               (if (null? os-stack)
                    (begin
                         (if (null? os_proc) '() (set! global-time (+ global-time context-switch-time)))
                         (if (null? myos)
                              (list '() '())
                              (list (cdr myos) (list (car myos)))
                              )
                         )
                    (let
                         ((temp (car os-stack)))
                         (set! os-stack (cdr os-stack))
                         (set! global-time (+ global-time context-switch-time))
                         (list myos (list temp))
                         )
                    )
               )
          )
     )

; This leaves the lists as they are.  Normally it could stop for OS
; calls or other things, but it isn't.
(define schedule-realtime
     (lambda (proc-list)
          (cdr proc-list)
          )
     )
